```plantuml
@startuml
'用户信息类'
class UserInfo{
    - UserID: String
    - createAt: Date
    - name: String
    - gender: String
    - age:String
    - styleInfo: List<UserStyleInfo>
    + get...()
    + set...()
    + requestGenerate()
    + requestrecommend()
    + save()
}
'用户风格信息类，每位用户可设置多个风格信息'
class UserStyleInfo{
    - objectID: String
    - createAt: Date
    - age: Int
    - gender: String
    - height: Int
    - weight: Int
    - season: String
    - customDesc: String
    - areaStyle: String
    - function: String
    - designIdea: String
    - artStyle: String
    - color: String
    + get...()
    + set...()
}

class GenerateResult{
    - GID: String
    - UID: String
    - content: String
    - image: String
    + get...()
    + set...()
    + save(image,content)
}

class Process{
    - generationService: GenerationService
    - recommendService: RecommendService
    - fashionService: FashionService
}

class GenerationService{
    + generate(UserInfo)
    + getResult(GID)
}

Process <.. GenerationService
GenerationService -- GenerateResult
UserInfo <.. Process
UserInfo -- UserStyleInfo
'用户偏好类，记录用户浏览偏好集合'
class UserPrefer{
    - objectID: String
    - UserID: String
    - ItemID: String
    - preference: number
    + get...()
    + set...()
}

class ItemInfo{
    - objectID: String
    - name: String
}
UserInfo -- UserPrefer
UserPrefer -- ItemInfo

class RecommendService{
    + recommend(UserInfo)
}

Process <.. RecommendService

class FashionResult{
    - FID: String
    - jumpLink: String
    - content: String
    + get...()
    + set...()
    + save(jumpLink,content)
}

class FashionService{
    + integrate()
}

FashionService -- FashionResult
Process <.. FashionService
@enduml
```