import { CommonModule } from '@angular/common';
import { Component, OnInit } from '@angular/core';
import { IonButton, IonContent, IonIcon } from '@ionic/angular/standalone';
import { addIcons } from 'ionicons';
import { bookmarkOutline, chatbubbleOutline, ellipsisHorizontal, heart, heartOutline, shareSocialOutline, } from 'ionicons/icons';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';

addIcons({ ellipsisHorizontal, bookmarkOutline, shareSocialOutline, chatbubbleOutline, heartOutline, heart })

@Component({
  selector: 'app-post',
  templateUrl: './post.component.html',
  styleUrls: ['./post.component.scss'],
  standalone: true,
  imports: [IonContent, IonIcon, IonButton, CommonModule]

})
export class PostComponent implements OnInit {
  posts: CloudObject[] = []; // 存储帖子
  resultUser: any;
  constructor() { }

  async ngOnInit() {
    const query = new CloudQuery('post'); // 创建查询对象
    console.log(query);
    query.include('user'); // 包含 user 属性
    this.posts = await query.find(); // 使用 find 方法获取所有帖子
    console.log(this.posts);
    
    
  }

  // 用于跟踪点赞状态
  isLiked: boolean = false;

  // 切换点赞状态
  toggleLike() {
    this.isLiked = !this.isLiked; // 切换状态
  }





}
