import { Component } from '@angular/core';
import { IonicModule } from '@ionic/angular'; // 导入 IonicModule
import { aperture, glasses, person, logoOctocat, menu, search } from 'ionicons/icons';
import { EditTagComponent } from '../edit-tag/edit-tag.component';
import { Router } from '@angular/router';
import { EditRatingStarComponent } from '../edit-rating-star/edit-rating-star.component';
import { FormsModule } from '@angular/forms'; // 导入 FormsModule
import { addIcons } from 'ionicons';
import { CommonModule } from '@angular/common';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';

addIcons({ menu, search });

@Component({
  selector: 'app-tab1',
  templateUrl: 'tab1.page.html',
  styleUrls: ['tab1.page.scss'],
  standalone: true,
  imports: [IonicModule, EditTagComponent, EditRatingStarComponent, FormsModule,CommonModule]
})
export class Tab1Page {
  selectedSegment: string = '发现'; // 默认选中“发现”

  constructor(private router: Router) {}

  segmentChanged(event: any) {
    this.selectedSegment = event.detail.value; // 更新选中的值
  }
goSearchPage(){
  this.router.navigate(['/tabs/test']);
}

posts: CloudObject[] = []; // 用于存储用户帖子
  currentUser: CloudUser | null = null; // 当前用户


  async ngOnInit() {
    // 获取当前用户
    this.currentUser = new CloudUser();
    await this.currentUser.current(); // 获取当前用户信息

    // 如果用户已登录，查询用户的帖子
    if (this.currentUser.id) {
      await this.fetchUserPosts();
    }
  }

  async fetchUserPosts() {
    const query = new CloudQuery('post');
    query.equalTo('user', this.currentUser?.toPointer()); // 查询当前用户的帖子
    this.posts = await query.find(); // 获取帖子列表
  }


  }

