
import express from 'express'; // 导入 express
import cors from 'cors'; // 导入 CORS 中间件
const app = express();
// 使用 CORS 中间件，允许所有来源的请求
app.use(cors());
// 解析请求体中的 JSON 数据
app.use(express.json()); // 解析 JSON 格式的请求体
app.use(express.urlencoded({ extended: true })); // 解析 URL 编码的请求体
// 处理 POST 请求
app.post('/post', (req, res) => {
    res.send(req.body); // 返回请求体中的数据
});
// 启动服务器，监听 3000 端口
app.listen(3000, () => {
    console.log('服务器启动成功');
});
